#!d:/Perl/bin/perl
##!/usr/bin/perl

use lib 'd:/Programs/Perl/lib';
#use lib 'D:/MyWebs/cgi-bin/Schedule/Admin';

use strict;
#use warnings;
use CGI::Carp qw(fatalsToBrowser);

use MyCGIApplication;
use CGI::Calendar;

our $DBMName           = 'mysql';
our $DBServer          = 'localhost';
our $DBUser            = 'schedule_user';
our $DBPassword        = 'OnnSennGeisya';
our $DBName            = "schedule_db";
our $ScheduleTableName = 'schedule_tbl';


my $App = new MyCGIApplication;
exit if($App->Initialize() < 0);
$App->SetOutputMode("HTML");

my $WebCharSet  = "sjis";
my $WebCharCode = "sjis";


my $DB = new SQLDB($DBMName);
$DB->Open($DBServer, $DBUser, $DBPassword, $DBName, undef, 0, 0);

my $C = new Calendar;
my $Year  = 2008;
my $Month = 12;
my $Day   = 1;
my $Apparatus = 'Holiday';
($Year, $Month, $Day) = $C->GetNowDate();

$App->print("");

my %Holiday;
$DB->Search($ScheduleTableName, "Year=$Year and Month=$Month and Apparatus='$Apparatus' and (DeleteTime is null or DeleteTime='' or DeleteTime='NULL')", "");
while(1) {
	my %Hit = $DB->GetNextHit();
	last if(!defined $Hit{sn});

#	foreach my $key (keys %Hit) {
#		print "<b>$key:</b> $Hit{$key}<br>\n";
#	}
	$Holiday{"$Hit{Year}/$Hit{Month}/$Hit{Day}"} = $Hit{Comment};
#$App->print("H: $Hit{Year}/$Hit{Month}/$Hit{Day}: $Hit{Comment}\n");
}

my %ToDo;
$Apparatus = 'Kamiya';
$DB->Search($ScheduleTableName, "Year=$Year and Month=$Month and Apparatus='$Apparatus' and (DeleteTime is null or DeleteTime='' or DeleteTime='NULL')", "");
while(1) {
	my %Hit = $DB->GetNextHit();
	last if(!defined $Hit{sn});
	$ToDo{"$Hit{Year}/$Hit{Month}/$Hit{Day}"} = "<b>%s</b>"; ##$Hit{Comment};
}

$C->ShowMonth($App, 
		{
		Minimize        => 1,
		ShowHeadingLine => 1,
		FontSize     => 1,
		pWeekDayText => [qw(Su M Tu W Th F Sa)],
#		pWeekDayText => [qw(      y)],
		Year         => $Year, 
		Month        => $Month, 
		Day          => $Day, 
		pHoliday     => \%Holiday, 
		pToDo        => \%ToDo
		}
		);

exit;
