package MyTime;
use Common;
@ISA = qw(Common);

use strict;

if($^O eq 'MSWin32') {
	use Win32;
}

#===============================================
# RXgN^AfXgN^
#===============================================
sub new
{
	my ($module) = @_;
	my $this = {};
	bless $this;
	$this->{StartTime}         = time();
	if($^O eq 'MSWin32') {
		$this->{StartGetTickCount} = Win32::GetTickCount();
	}
	return $this;
}

sub DESTROY
{
	my $this = shift;
	$this->SUPER::DESTROY(@_);
}

#===============================================
# ʊ֐
#===============================================

# Win32::GetTickCountgA$StartTiměoߎԂԂ
# 49o߂Ƃ̑΍ƂāA$timeɂȂƂ2^32 msecĂ
# ōŒ49AWindowsNォvOsꍇ98x܂Ŏg
sub GetTime
{
	my ($this, $SubtractStartTime) = @_;
	$SubtractStartTime = 0 if(!defined $SubtractStartTime);

	if($^O eq 'MSWin32') {
		my $now = Win32::GetTickCount();
		my $passed = $now - $this->{StartGetTickCount};
		if($passed >= 0.0) {
			return $passed * 0.001 if($SubtractStartTime);
			return $now * 0.001;
		}
		else {
			my $nowtime = time();
			my $n = int( ($nowtime - $this->{StartTime}) / 4294967.296 + 0.001);
			$now = $now * 0.001 + 4294967.296 * $n;
			return ($now - $this->{StartGetTickCount} * 0.001) if($SubtractStartTime);
			return $now;
		}
	}
	else {
		return time() - $this->{StartTime} if($SubtractStartTime);
		return time();
	}
}

1;
