use lib 'd:/Programs/Perl/lib';
use Crystal::VASP;

my $v = new VASP;
my $pHash = $v->ReadPOTCARtoHash("INCAR");
foreach my $key (sort keys %$pHash) {
#	print "$key: $pHash->{$key}\n";
}
#exit;
for(my $i = 0 ; ; $i++) {
	my $key = "PseudoPotential$i";
	last if(!defined $pHash->{$key});

#	print "$i: $pHash->{$key}\n";
	my $p = $pHash->{"${key}Hash"};
	print "$i: $p->{AtomName}\n";
	foreach my $key (sort keys %$p) {
		print "  $key: $p->{$key}\n";
	}
}

print "\n";

my $nVEL = $v->GetTotalValenceElectrons("INCAR");
print "nVEL = $nVEL\n";

my ($pAtomName, $pSiteIndex, $pCharge, $pMagnetization) = $v->GetFinalIonCharges("INCAR");
for(my $i = 0 ; $i < @$pAtomName ; $i++) {
	print "$i: $pAtomName->[$i]: Charge=$pCharge->[$i]: Mag=$pMagnetization->[$i]\n";
}
