#!/bin/bash

SCRIPTDir=`pwd`/script
VASPDir=$TkPerlDir/VASP
CMD="/usr/bin/perl $VASPDir/VASP.pl"

TemplateDir=Original.AllFixed
TemplateRootDir=`pwd`
TemplatePOSCARFlagDir=`pwd`/template.Relaxed

iSite=108
xarray="43333 45000 46667 48333 50000"
#xarray="41667 43333 45000 46667 48333 50000"
post=


#cp $TemplateSymDir/POSCAR $TemplateDir

#===========================
# Calculate symmetry lines
#===========================
#if [ -f $RelaxedSymPOSCAR ]; then
#	cp $RelaxedSymPOSCAR $TemplateDir/POSCAR
#fi
$SCRIPTDir/CalcDiagonal2FromTemplate.sh $SCRIPTDir $TemplateRootDir $TemplatePOSCARFlagDir "$xarray" $iSite $post

#===========================
# Post processors
#===========================
#$SCRIPTDir/MergePositionsInCIFs.pl --Positions=$iSite 2525/SCF MergedCIF.cif
$SCRIPTDir/MakeSummaryCSV2.pl --Positions=$iSite --AtomType=$AtomType
