#!/bin/bash

SCRIPTDir=`pwd`/script
VASPDir=$TkPerlDir/VASP
CMD="/usr/bin/perl $VASPDir/VASP.pl"

#TemplateDir=Original
TemplateSymDir=Original.sym
#RelaxedSymPOSCAR=$TemplateSymDir/POSCAR.relaxed

iSite=16
AtomType=Se
xarray="00 05 10 15 20 25 30 35 40 45 50"
yarray="00 05 10 15 20 25 30 35 40 45 50"
TemplateSuffixArray="1 2 3 4 5 last"
#yForLine=00
post=

#cp $TemplateSymDir/POSCAR $TemplateDir

#===========================
# Calculate all
#===========================
#if [ -f $RelaxedSymPOSCAR ]; then
#	cp $RelaxedSymPOSCAR $TemplateDir/POSCAR
#fi
$SCRIPTDir/CalcMap-MultiStep.sh $SCRIPTDir $TemplateSymDir "$TemplateSuffixArray" "$xarray" "$yarray" $iSite $post
#$SCRIPTDir/CalcMap-MultiStep.sh $SCRIPTDir $TemplateDir "$xarray" "$yarray" $iSite $post

#===========================
# Post processors
#===========================
#$SCRIPTDir/MergePositionsInCIFs.pl --Positions=$iSite 2525/SCF MergedCIF.cif
#$SCRIPTDir/MakeSummaryCSV2.pl --Positions=$iSite --AtomType=$AtomType
