#!/bin/bash

VASPDir=$TkPerlDir/VASP
CMD="/usr/bin/perl $VASPDir/VASP.pl"

SCRIPTDir=$1
TemplateDir=$2
iSite=$3
x=$4
y=$5
post=$6
DebugMode=0

WorkDir=$x$y$post
if [ -d $WorkDir ]; then
	echo "[Work]: [$WorkDir] exists. Skip."
else
	echo Work for [$WorkDir]

# Execute VASP
	if [ "$DebugMode" = "1" ]; then
		mkdir $WorkDir
	else
		$SCRIPTDir/NextCalc.sh $TemplateDir $WorkDir $iSite 0.$x 0.$y $post
	fi

#================================
# Copy to symmetry positions
#================================
	$SCRIPTDir/ExpandSymmetry.sh $iSite $x $y $post
fi
