#include "Constants.h"
//#include "Common.h"

//extern FILE *_out;
//const int BUF_LEN = 2048;
const int NMAX_TOKEN = 50;

const double CConstants::a0 = 0.529e-10; // m Bohr radius
const double CConstants::me = 9.11e-31;    // kg
const double CConstants::NA = 6.02204e23;  // mol-1
const double CConstants::hbar = 1.05458E-34; // J*s
const double CConstants::h    = 6.62617E-34; // J*s
const double CConstants::e = 1.60218e-19;  // C
const double CConstants::R = 1.98719;      //cal/mol/K
const double CConstants::e0 = 8.85418e-12; // F/m
const double CConstants::u0 = 1.25663e-6;  // H/m
const double CConstants::c = 2.99792e8;   // m/s
const double CConstants::toeV = 1.0 / CConstants::e;
const double CConstants::toJ  = CConstants::e;
const double CConstants::kB = 1.38066e-023; // J/K
const double CConstants::pi = 3.1415926535;
const complex<double> CConstants::i = complex<double>(0.0, 1.0); // Imaginary unit
const double CConstants::toDeg = 180.0 / CConstants::pi;
const double CConstants::toRad = CConstants::pi / 180.0;

const char TAB = '\t';
const char LF  = '\n';
