// CurveFitDoc.cpp : CCurveFitDoc NX̓̒`s܂B
//

#include "stdafx.h"
#include "CurveFit.h"
#include "CurveFitDoc.h"
#include "CntrItem.h"
#include "SetupScaleDialog.h"
#include "SetupGraphFrame.h"
#include "SetupCurveFitView.h"
#include "SelectDataDialog.h"
#include "CurveFitEditView.h"
#include "SetupOptionDialog.h"
#include "..\IniFile.h"

extern CCurveFitApp theApp;
extern CIniFile *IniFile;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCurveFitDoc

IMPLEMENT_DYNCREATE(CCurveFitDoc, CRichEditDoc)

BEGIN_MESSAGE_MAP(CCurveFitDoc, CRichEditDoc)
	//{{AFX_MSG_MAP(CCurveFitDoc)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_VIEW_REDRAW, OnViewRedraw)
	ON_COMMAND(ID_VIEW_RESTOREVIEWSCALE, OnViewRestoreviewscale)
	ON_COMMAND(ID_VIEW_CHANGEVIEWSCALE, OnViewChangeviewscale)
	ON_COMMAND(ID_VIEW_EDITINIFILE, OnViewEditinifile)
	ON_COMMAND(ID_VIEW_SETUPGRAPHFRAME, OnViewSetupgraphframe)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_FILE_SAVEDATAAS, OnFileSavedataas)
	ON_COMMAND(ID_OPTION_SETUPOPTION, OnOptionSetupoption)
	ON_COMMAND(ID_VIEW_VIEWCURVES, OnViewViewcurves)
	ON_UPDATE_COMMAND_UI(ID_VIEW_VIEWCURVES, OnUpdateViewViewcurves)
	ON_COMMAND(ID_VIEW_VIEWCURRENTCURVE, OnViewViewcurrentcurve)
	ON_UPDATE_COMMAND_UI(ID_VIEW_VIEWCURRENTCURVE, OnUpdateViewViewcurrentcurve)
	ON_COMMAND(ID_VIEW_VIEWCALC, OnViewViewcalc)
	ON_UPDATE_COMMAND_UI(ID_VIEW_VIEWCALC, OnUpdateViewViewcalc)
	ON_COMMAND(ID_VIEW_VIEWBG, OnViewViewbg)
	ON_UPDATE_COMMAND_UI(ID_VIEW_VIEWBG, OnUpdateViewViewbg)
	ON_COMMAND(ID_VIEW_PROCESSXRDData, OnVIEWPROCESSXRDData)
	ON_UPDATE_COMMAND_UI(ID_VIEW_PROCESSXRDData, OnUpdateVIEWPROCESSXRDData)
	ON_COMMAND(ID_VIEW_PROCESSRAMANDATA, OnViewProcessramandata)
	ON_UPDATE_COMMAND_UI(ID_VIEW_PROCESSRAMANDATA, OnUpdateViewProcessramandata)
	ON_COMMAND(ID_OPTION_LAUNCHEDITOR, OnOptionLauncheditor)
	ON_COMMAND(ID_FILE_SAVERIETANFORMAT, OnFileSaverietanformat)
	ON_COMMAND(ID_READRIETANFILES, OnReadrietanfiles)
	ON_COMMAND(ID_FILE_UPDATECURRENTFILE, OnFileUpdatecurrentfile)
	ON_COMMAND(ID_READTEXTFILES, OnReadtextfiles)
	//}}AFX_MSG_MAP
	// ftHg OLE Rei̒`gp\ɂ܂B
	ON_UPDATE_COMMAND_UI(ID_OLE_EDIT_LINKS, CRichEditDoc::OnUpdateEditLinksMenu)
	ON_COMMAND(ID_OLE_EDIT_LINKS, CRichEditDoc::OnEditLinks)
	ON_UPDATE_COMMAND_UI(ID_OLE_VERB_FIRST, CRichEditDoc::OnUpdateObjectVerbMenu)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCurveFitDoc NX̍\z/

CCurveFitDoc::CCurveFitDoc()
{
	// TODO: ̈ʒuɂPxĂ΂\zp̃R[hǉĂB
	m_Comment = "";
	CreateGraphFrameWithData(1);
	m_ViewBackground = IniFile->Getbool("GraphView", "ViewBackground", 1);
	m_ViewCalc       = IniFile->Getbool("GraphView", "ViewCalc", 1);
	m_ViewCurves     = IniFile->Getbool("GraphView", "ViewCurves", 1);
	m_ViewCurrentCurve = IniFile->Getbool("GraphView", "ViewCurrentCurve", 1);
	m_iYAxisType = YAXISTYPE_LINEAR;
}

CCurveFitDoc::~CCurveFitDoc()
{
	IniFile->Writebool("GraphView", "ViewBackground", m_ViewBackground);
	IniFile->Writebool("GraphView", "ViewCalc", m_ViewCalc);
	IniFile->Writebool("GraphView", "ViewCurves", m_ViewCurves);
	IniFile->Writebool("GraphView", "ViewCurrentCurve", m_ViewCurrentCurve);
}

BOOL CCurveFitDoc::OnNewDocument()
{
	if (!CRichEditDoc::OnNewDocument())
		return FALSE;

	// TODO: ̈ʒuɍďǉĂB
	// (SDI hLg͂̃hLgėp܂B)
	NewDocument();
	return TRUE;
}

CRichEditCntrItem* CCurveFitDoc::CreateClientItem(REOBJECT* preo) const
{
	// ̃NX const w𖳌ɂ邽߂ɃLXg܂
	return new CCurveFitCntrItem(preo, (CCurveFitDoc*) this);
}



/////////////////////////////////////////////////////////////////////////////
// CCurveFitDoc VAC[[V

void CCurveFitDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: ̈ʒuɕۑp̃R[hǉĂB
	}
	else
	{
		// TODO: ̈ʒuɓǂݍݗp̃R[hǉĂB
		CFile *pFile = ar.GetFile();
		CString filepath = pFile->GetFilePath();
		GetSetupCurveFitView()->ReadFile(filepath);
	}

	// {NX CRichEditDoc ĂяoƂɂăRei hLg
	// COleClientItem IuWFNg̃VAC[[V\ɂȂ܂B
	CRichEditDoc::Serialize(ar);
}

/////////////////////////////////////////////////////////////////////////////
// CCurveFitDoc NX̐ff

#ifdef _DEBUG
void CCurveFitDoc::AssertValid() const
{
	CRichEditDoc::AssertValid();
}

void CCurveFitDoc::Dump(CDumpContext& dc) const
{
	CRichEditDoc::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCurveFitDoc R}h

void CCurveFitDoc::OnFileOpen() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	OnNewDocument();
	GetSetupCurveFitView()->SetInputpath();
/*
	static bool IsLoading = false;
	if(IsLoading) return;
	IsLoading = true;
	CFileDialog fd(false, NULL, NULL, OFN_HIDEREADONLY | OFN_FILEMUSTEXIST, 
		"All Files (*.*)|*.*||");
	if(fd.DoModal() != IDOK) return;

	SetCursor(theApp.LoadStandardCursor(IDC_WAIT));
	ReadDataFile(fd.GetPathName().GetBuffer(256));
	UpdateAllViews(NULL);
	IsLoading = false;
	SetCursor(theApp.LoadStandardCursor(IDC_ARROW));
*/
}

int CCurveFitDoc::ReadDataFile(LPSTR filename)
{
	int iDataIndex = 0;

	m_FileName = filename;
	if(CreateGraphFrameWithData(1) <= 0)
	{
		MessageBox(NULL, "Can't Create GraphFrame", "CDataFinderDoc::ReadDataFile", MB_OK);
		return -1;
	}
	CVariousGraphFrameArray *pFrameArray = GetGraphFrameArray();
	if(pFrameArray == NULL)
	{
		MessageBox(NULL, "Can't Get GraphFrameArray", "CDataFinderDoc::ReadDataFile", MB_OK);
		return -1;
	}
	CGraphFrame *pFrame = GetGraphFrame(0);
	if(pFrame == NULL)
	{
		MessageBox(NULL, "Can't Get GraphFrame", "CDataFinderDoc::ReadDataFile", MB_OK);
		return -1;
	}

	m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_INVALID;
	char FileTitle[256];
	char *cp = strrchr(filename, '.');
	if(cp == NULL)
	{
		sprintf(FileTitle, "%s (Invalid Data)", filename);
		SetPathName(FileTitle, TRUE);
		return -1;
	}
	int ret;
	if(stricmp(cp, ".csv") == 0) //Rigaku XRF data
	{
		ret = GetOriginalData()->ReadRigakuXRFData(filename);
		if(ret == DATAFILETYPE_INVALID)
		{
			sprintf(FileTitle, "%s (Invalid Data Type)", filename);
		}
		if(ret == 1) //XRF data
		{
			pFrame->SetXAxisString(CString("Theta / degree"));
			pFrame->SetYAxisString(CString("Signale"));
			sprintf(FileTitle, "%s (Rigaku XRF Data)", filename);
			m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_XRD;
		}
	}
	else if(stricmp(cp, ".ras") == 0) //SmartLab data
	{
		ret = GetOriginalData()->ReadSmartLabRASData(filename);
		if(ret == 1)
		{
			pFrame->SetXAxisString(CString("Angle / deg"));
			pFrame->SetYAxisString(CString("Intensity"));
//			pFrame->SetReverseAxisX(true);
//			pFrame->SetReverseAxisY(true);
			sprintf(FileTitle, "%s (SmartLab RAS Data)", filename);
			m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_IR;
		}
		else //IR Binary data
			sprintf(FileTitle, "%s (IR binary Data not supported)", filename);
	}
	else if(stricmp(cp, ".ir") == 0) //Old IR data
	{
		ret = GetOriginalData()->ReadOldIRData(filename);
		if(ret == 1) //IR data
		{
			pFrame->SetXAxisString(CString("Wave number / cm-1"));
			pFrame->SetYAxisString(CString("Transmittance / %"));
//			pFrame->SetReverseAxisX(true);
//			pFrame->SetReverseAxisY(true);
			sprintf(FileTitle, "%s (Old IR Data)", filename);
			m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_IR;
		}
		else //IR Binary data
			sprintf(FileTitle, "%s (IR binary Data not supported)", filename);
	}
	else if(stricmp(cp, ".asc") == 0)
	{
		ret = GetOriginalData()->ReadASCData(filename);
		if(ret == 1) //IR Data
		{
			pFrame->SetXAxisString(CString("Wave number / cm-1"));
			pFrame->SetYAxisString(CString("Transmittance / %"));
//			pFrame->SetReverseAxisX(true);
			sprintf(FileTitle, "%s (IR Data)", filename);
			m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_IR;
		}
		else if(ret == 2) //Tokuyama Raman Data
		{
			pFrame->SetXAxisString(CString("Wave number / cm-1"));
			pFrame->SetYAxisString(CString("Raman Intensity"));
//			pFrame->SetReverseAxisX(true);
			sprintf(FileTitle, "%s (Tokuyama Raman Data)", filename);
			m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_RAMAN;
		}
	}
	else if(stricmp(cp, ".mrd") == 0)
	{
		ret = GetOriginalData()->ReadMRDData(filename);
		if(ret == 1) //IR Data
		{
			pFrame->SetXAxisString(CString("CuKa 2Q"));
			pFrame->SetYAxisString(CString("Intensity / cps"));
//			pFrame->SetReverseAxisX(true);
			sprintf(FileTitle, "%s (IR Data)", filename);
			m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_XRD;
		}
	}
	else if(strlen(cp) == 4 && (cp[1] == 'X'||cp[1] == 'x') 
			&& strchr("0123456789", cp[2]) != NULL
			&& strchr("0123456789", cp[3]) != NULL)
	{
		ret = GetOriginalData()->ReadMRDXData(filename);
		if(ret == 1) //IR Data
		{
			pFrame->SetXAxisString(CString("CuKa 2Q"));
			pFrame->SetYAxisString(CString("Intensity / cps"));
//			pFrame->SetReverseAxisX(true);
			sprintf(FileTitle, "%s (IR Data)", filename);
			m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_XRD;
		}
	}
	else if(stricmp(cp, ".od") == 0) //OD data
	{
		ret = GetOriginalData()->ReadODData(filename);
		pFrame->SetXAxisString(CString("Wave length / nm"));
		pFrame->SetYAxisString(CString("Optical Density"));
		sprintf(FileTitle, "%s (OD Data)", filename);
	}
	else if(strnicmp(cp, ".qe", 3) == 0) //QE data
	{
		ret = GetOriginalData()->ReadQEData(filename);
		pFrame->SetXAxisString(CString("Wave length / nm"));
		pFrame->SetYAxisString(CString("Quantum efficiency"));
		sprintf(FileTitle, "%s (QE Data)", filename);
	}
	else if(stricmp(cp, ".txt") == 0) //New Raman data
	{
//MessageBox(NULL, "txt", "txt", MB_OK);
		ret = GetOriginalData()->ReadGeneralTextData(filename);
		if(ret == 1) // General Text XRD data
		{
			pFrame->SetXAxisString(CString("CuKa 2Theta"));
			pFrame->SetYAxisString(CString("Diffraction intensity"));
			sprintf(FileTitle, "%s (XRD Data)", filename);
			m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_XRD;
		}
char s[256];
		if(!ret) {
			ret = GetOriginalData()->ReadnDataXYTextData(filename);
//sprintf(s, "ret=%d", ret);
//MessageBox(NULL, "ReadnDataXYTextData", s, MB_OK);
			if(ret == 1) {
				pFrame->SetXAxisString(CString("CuKa 2Theta"));
				pFrame->SetYAxisString(CString("Diffraction intensity"));
				sprintf(FileTitle, "%s (XRD Data)", filename);
				m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_XRD;
			}
		}
		if(!ret) {
			ret = GetOriginalData()->ReadPLF4500Data(filename);
//sprintf(s, "ret=%d", ret);
//MessageBox(NULL, "ReadPLF4500Data", s, MB_OK);
			if(ret == 1) {
				pFrame->SetXAxisString(CString("Wavelength / nm"));
				pFrame->SetYAxisString(CString("PL intensity"));
				sprintf(FileTitle, "%s (PL Data)", filename);
				m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_RAMAN;
			}
		}
		if(!ret) {
			ret = GetOriginalData()->ReadXRDRint2000Data(filename);
//sprintf(s, "ret=%d", ret);
//MessageBox(NULL, "ReadXRDRint2000Data", s, MB_OK);
			if(ret == 1) {
				pFrame->SetXAxisString(CString("CuKa 2Theta"));
				pFrame->SetYAxisString(CString("Diffraction intensity"));
				sprintf(FileTitle, "%s (XRD Data)", filename);
				m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_XRD;
			}
		}
		if(!ret) {
			ret = GetOriginalData()->ReadRamanTxtData(filename);
			if(ret == 1) //Raman data
			{
				pFrame->SetXAxisString(CString("Wave number / cm-1"));
				pFrame->SetYAxisString(CString("Raman intensity"));
				sprintf(FileTitle, "%s (Raman Data)", filename);
				m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_RAMAN;
			}
			else if(ret == 2)
			{
				pFrame->SetXAxisString(CString("CuKa 2Theta"));
				pFrame->SetYAxisString(CString("Diffraction intensity"));
				sprintf(FileTitle, "%s (XRD Data)", filename);
				m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_XRD;
			}

		}
	}
	else if(stricmp(cp, ".dat") == 0) //Raman or other data
	{
		ret = GetOriginalData()->ReadDatFile(filename);
		if(ret == 1) //Raman data
		{
			pFrame->SetXAxisString(CString("Wave number / cm-1"));
			pFrame->SetYAxisString(CString("Raman intensity"));
			sprintf(FileTitle, "%s (Raman Data)", filename);
			m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_RAMAN;
		}
		else if(ret == 2) //degradation data
		{
			pFrame->SetXAxisString(CString("Time / s"));
			pFrame->SetYAxisString(CString("Photo current / A"));
			sprintf(FileTitle, "%s (Degradation Measurement Data)", filename);
		}
		else //invalid data
			sprintf(FileTitle, "%s (Invalid Data)", filename);
	}
	else if(stricmp(cp, ".ram") == 0) //Raman data
	{
		ret = GetOriginalData()->ReadRamanData(filename);
		pFrame->SetXAxisString(CString("Wave number / cm-1"));
		pFrame->SetYAxisString(CString("Raman intensity"));
		sprintf(FileTitle, "%s (Raman Data)", filename);
		m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_RAMAN;
	}
	else if(stricmp(cp, ".rmn") == 0) //Raman Smoothed data
	{
		ret = GetOriginalData()->ReadRamanRmnData(filename);
		pFrame->SetXAxisString(CString("Wave number / cm-1"));
		pFrame->SetYAxisString(CString("Raman intensity"));
		sprintf(FileTitle, "%s (Raman smoothed Data)", filename);
		m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_RAMAN;
	}
	else if(strchr("0123456789", *(cp+1)) != NULL) //Mac Science Corp., MXP XRD data
	{
		ret = GetOriginalData()->ReadXRDMXPData(filename);
		pFrame->SetXAxisString(CString("Diffraction angle 2Theta / deg."));
		pFrame->SetYAxisString(CString("Intensity"));
		sprintf(FileTitle, "%s (XRD Data)", filename);
		m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_XRD;
	}
	else if(stricmp(cp, ".xdt") == 0) //Chichibu Onoda Cement Corp. XRD data
	{
		ret = GetOriginalData()->ReadXRDXDTData(filename);
		pFrame->SetXAxisString(CString("Diffraction angle 2Theta / deg."));
		pFrame->SetYAxisString(CString("Intensity"));
		sprintf(FileTitle, "%s (XRD Data)", filename);
		m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_XRD;
	}
	else if(stricmp(cp, ".xrd") == 0) //XRD data
	{
		CSelectDataDialog sdd;
		sdd.SetDataLabel("Datum in the data file");
		char str[256];
		FILE *in;
		if((in = fopen(filename, "r")) == NULL)
		{
			CString err;
			err.Format("Can't read [%s]", filename);
			MessageBox(NULL, err, "Error", MB_OK);
			return -1;
		}
		int nSec = 1;
		while(!feof(in))
		{
			fgets(str, 256, in);
			if(strncmp(str, "*SEC_COUNT", 10) == 0)
			{
				cp = strchr(str, '=');
				if(cp) nSec = atoi(cp+1);
				break;
			}
		}
		for(int i = 0 ; i <  nSec ; i++)
		{
			double start, stop;
			while(!feof(in))
			{
				fgets(str, 256, in);
				if(strncmp(str, "*START", 6) == 0)
				{
					cp = strchr(str, '=');
					if(cp) start = atof(cp+1);
				}
				else if(strncmp(str, "*STOP", 5) == 0)
				{
					cp = strchr(str, '=');
					if(cp) stop = atof(cp+1);
					break;
				}
			}
			CString s;
			s.Format("%d: %g - %g", i, start, stop);
			sdd.AddList(s);
		}
		fclose(in);
		if(nSec > 1) iDataIndex = sdd.DoModal();
		if(iDataIndex < 0) iDataIndex = 0;

		ret = GetOriginalData()->ReadXRDData(filename, iDataIndex);
		pFrame->SetXAxisString(CString("Diffraction angle 2Theta / deg."));
		pFrame->SetYAxisString(CString("Intensity"));
		sprintf(FileTitle, "%s (XRD Data)", filename);
		m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_XRD;
	}
	else if(stricmp(cp, ".csv") == 0) //TDS (ETL) data
	{
		CSelectDataDialog sdd;
		sdd.SetDataLabel("Datum in the data file");
		char str[1024];
		FILE *in;
		if((in = fopen(filename, "r")) == NULL)
		{
			CString err;
			err.Format("Can't read [%s]", filename);
			MessageBox(NULL, err, "Error", MB_OK);
			return -1;
		}
		fgets(str, 1024, in);
		fgets(str, 1024, in);
		int ncurve = 0;
		LPSTR cp = str;
		while(1)
		{
			cp = strchr(cp, ',');
			if(cp == NULL) break;
			ncurve++;
			cp++;
		}
		ncurve -= 2;
		fclose(in);
		cp = strchr(str, ',');
		if(cp) cp = strchr(cp+1, ',');
		if(cp) cp++;
		for(int i = 0 ; i <  ncurve ; i++)
		{
			if(cp == NULL) break;
			CString s;
			s.Format("%d: Mass/z=%g", i, atof(cp));
			sdd.AddList(s);
			cp = strchr(cp, ',');
			if(cp) cp++;
			else break;
		}
		fclose(in);
		if(ncurve > 1) iDataIndex = sdd.DoModal();
		if(iDataIndex < 0) iDataIndex = 0;

		ret = GetOriginalData()->ReadTDSData(filename, iDataIndex);
		pFrame->SetXAxisString(CString("Temperture / C"));
		pFrame->SetYAxisString(CString("Intensity"));
		pFrame->CalcFrameViewRange();
		sprintf(FileTitle, "%s (TDS Data)", filename);
		m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_RAMAN;
	}
	else if(stricmp(cp, ".int") == 0)
	{
		ret = GetOriginalData()->ReadRietanIntData(filename);
		pFrame->SetXAxisString(CString("2Theta"));
		pFrame->SetYAxisString(CString("Diffraction Intensity"));
		sprintf(FileTitle, "%s (Rietan INT Data)", filename);
		m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_XRD;
	}
	else if(stricmp(cp, ".pat") == 0)
	{
		ret = GetOriginalData()->ReadRietanPatData(filename, 0);
		CVariousData *pData = (CVariousData*)(pFrame->AddData(&(m_PeakSearch.m_Total)));
		pData->ReadRietanPatData(filename, 1);
		pData->m_LineLineColor = RGB(0xff, 0, 0);
		pData = (CVariousData *)&(m_PeakSearch.m_BG);
		if(pData->ReadRietanPatData(filename, 2) > 0)
		{
			pData = (CVariousData *)pFrame->AddData(&(m_PeakSearch.m_BG));
			pData->m_LineLineColor = RGB(0, 0xff, 0);
		}
		pFrame->SetXAxisString(CString("2Theta"));
		pFrame->SetYAxisString(CString("Diffraction Intensity"));
		sprintf(FileTitle, "%s (Rietan PAT Data)", filename);
		m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_XRD;
	}
	else
	{
		ret = GetOriginalData()->ReadXRDMXPData2(filename);
		if(ret == 1) //MXP new data
		{
			pFrame->SetXAxisString(CString("Diffraction angle 2Theta / deg."));
			pFrame->SetYAxisString(CString("Intensity"));
			sprintf(FileTitle, "%s (XRD Data)", filename);
			m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_XRD;
		}
		else //invalid data
		{
			sprintf(FileTitle, "%s (Invalid Data)", filename);
			SetPathName(FileTitle, TRUE);
			return -1;
		}
	}
	if(ret > 0)
	{
		(m_GraphFrameArray.GetGraphFrame(0))->CalcFrameViewRange();
		SetPathName(FileTitle, TRUE);
	}
	else
	{
		sprintf(FileTitle, "%s (Invalid Data)", filename);
		SetPathName(FileTitle, TRUE);
		return -1;
	}

	return iDataIndex;
}

int CCurveFitDoc::CreateGraphFrameWithData(int num)
{
	char str[256];
	IniFile->GetString("Setup", "GraphPosition", "20 70 80 10", str);
	double x0, y0, x1, y1;
	sscanf(str, "%lg %lg %lg %lg", &x0, &y0, &x1, &y1);
	CVariousGraphFrameArray *pFrameArray = GetGraphFrameArray();
	if(pFrameArray == NULL)
	{
		MessageBox(NULL, "Can't Get FrameArray", "CDataGraphView::CreateGraphFrame", MB_OK);
		return -1;
	}
	pFrameArray->RemoveAllData();
	for(int i = 0 ; i < num ; i++)
		pFrameArray->Add(x0, y0, x1, y1);

	CGraphFrame *pFrame = m_GraphFrameArray.GetGraphFrame(0);
	if(pFrame) pFrame->SetForceViewRangeYMin(0.0);
	CGraphData *pData = GetOriginalData();
	if(pData == NULL)
	{
		MessageBox(NULL, "Can't Get Original Data", "CDataGraphView::CreateGraphFrame", MB_OK);
		return -1;
	}
	pFrame->AddData(pData);
	pFrameArray->CalcAllFrameViewRange();
	return 1;
}

void CCurveFitDoc::OnViewRedraw() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	UpdateAllViews(NULL);	
}

void CCurveFitDoc::OnViewRestoreviewscale() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CGraphFrame *pFrame = GetGraphFrame(0);
	if(pFrame == NULL) return;
	pFrame->CalcFrameViewRange();
	UpdateAllViews(NULL);
}

void CCurveFitDoc::OnViewChangeviewscale() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CGraphFrameArray *pFrameArray = GetGraphFrameArray();
	if(pFrameArray == NULL) return;
	CSetupScaleDialog ssd(pFrameArray);
	
	if(ssd.DoModal() == IDOK)
	{
		UpdateAllViews(NULL);
	}
}

void CCurveFitDoc::OnViewEditinifile() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CString command;
	char editor[256];
	IniFile->GetString("Preferences", "Editor", "notepad.exe", editor);
	command.Format("\"%s\" \"%s\"", editor, IniFile->IniFile());
	if(WinExec(command, SW_SHOW) < 32)
	{
		CString err;
		err = "Can't execute [" + command + "]";
		MessageBox(NULL, err, "Error in CCurveFitDoc::OnViewEditinifile", MB_OK);
	}
}

void CCurveFitDoc::OnViewSetupgraphframe() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CSetupGraphFrame sgf(&m_GraphFrameArray);
	sgf.m_bClipGraphFrame = IniFile->GetBool("Setup", "ClipGraphFrame", false);
	
	if(sgf.DoModal() == IDOK)
	{
		CGraphFrame *pFrame = GetGraphFrame(0);
		if(pFrame == NULL) return;
		char str[256];
		sprintf(str, "%g %g %g %g", pFrame->GraphPosX0(), pFrame->GraphPosY0(),
									pFrame->GraphPosX1(), pFrame->GraphPosY1());
		IniFile->WriteString("Setup", "GraphPosition", str);
		IniFile->WriteBool("Setup", "ClipGraphFrame", sgf.m_bClipGraphFrame);
		UpdateAllViews(NULL);
	}
}

CSetupCurveFitView* CCurveFitDoc::GetSetupCurveFitView()
{
	POSITION pos = GetFirstViewPosition();
	CView *view;
	while(1)
	{
		view = GetNextView(pos);
		if(view == NULL) break;
		if(view->IsKindOf(RUNTIME_CLASS(CSetupCurveFitView))) return (CSetupCurveFitView *)view;
	}
	return NULL;
}

CCurveFitEditView* CCurveFitDoc::GetCurveFitEditView()
{
	POSITION pos = GetFirstViewPosition();
	CView *view;
	while(1)
	{
		view = GetNextView(pos);
		if(view == NULL) break;
		if(view->IsKindOf(RUNTIME_CLASS(CCurveFitEditView))) return (CCurveFitEditView *)view;
	}
	return NULL;
}

void CCurveFitDoc::OnEditCopy() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CGraphFrame frame;
	frame.AddData(m_PeakSearch.m_pOriginalData);
	frame.AddData(&(m_PeakSearch.m_BG));
	frame.AddData(&(m_PeakSearch.m_Total));
	for(int i = 0 ; i < m_PeakSearch.m_Curves.nGraphData() ; i++)
		frame.AddData(m_PeakSearch.m_Curves.GetGraphData(i));
	int ret = frame.SelectData();
	if(ret < 0) return;
	CGraphData *pData = frame.GetGraphData(ret);
	if(pData == NULL) return;
	pData->CopyDataToClipboard();
}

void CCurveFitDoc::OnFileSavedataas() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CGraphFrame frame;
	frame.AddData(m_PeakSearch.m_pOriginalData);
	frame.AddData(&(m_PeakSearch.m_BG));
	frame.AddData(&(m_PeakSearch.m_Total));
	for(int i = 0 ; i < m_PeakSearch.m_Curves.nGraphData() ; i++)
		frame.AddData(m_PeakSearch.m_Curves.GetGraphData(i));
	int ret = frame.SelectData();
	if(ret < 0) return;
	CGraphData *pData = frame.GetGraphData(ret);
	if(pData == NULL) return;
	
	char str[256];
	IniFile->GetString("Preferences", "WorkDir", "", str);
	if(*str != 0) SetCurrentDirectory(str);
	CFileDialog fd(false, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
		"Text File (*.txt)|*.txt|All Files (*.*)|*.*||");
	if(fd.DoModal() != IDOK) return;

	pData->SaveAsTextFormat((LPCSTR)fd.GetPathName());
}

BOOL CCurveFitDoc::SaveModified() 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	return 1;
//	return CRichEditDoc::SaveModified();
}

void CCurveFitDoc::OnOptionSetupoption() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CSetupOptionDialog sod;

	sod.DoModal();
}

void CCurveFitDoc::OnViewViewcurves() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	m_ViewCurves = !m_ViewCurves;
	UpdateAllViews(NULL);
}

void CCurveFitDoc::OnUpdateViewViewcurves(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	if(m_ViewCurves) pCmdUI->SetCheck(1);
	else pCmdUI->SetCheck(0);
}

void CCurveFitDoc::OnViewViewcurrentcurve() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	m_ViewCurrentCurve = !m_ViewCurrentCurve;
	UpdateAllViews(NULL);
}

void CCurveFitDoc::OnUpdateViewViewcurrentcurve(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	if(m_ViewCurrentCurve) pCmdUI->SetCheck(1);
	else pCmdUI->SetCheck(0);
}

void CCurveFitDoc::OnViewViewcalc() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	m_ViewCalc = !m_ViewCalc;
	UpdateAllViews(NULL);
}

void CCurveFitDoc::OnUpdateViewViewcalc(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	if(m_ViewCalc) pCmdUI->SetCheck(1);
	else pCmdUI->SetCheck(0);
}

void CCurveFitDoc::OnViewViewbg() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	m_ViewBackground = !m_ViewBackground;
	UpdateAllViews(NULL);
}

void CCurveFitDoc::OnUpdateViewViewbg(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	if(m_ViewBackground) pCmdUI->SetCheck(1);
	else pCmdUI->SetCheck(0);
}

void CCurveFitDoc::OnVIEWPROCESSXRDData() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_XRD;
	UpdateAllViews(NULL);
}

void CCurveFitDoc::OnUpdateVIEWPROCESSXRDData(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	if(m_PeakSearch.m_SpectrumKind == PEAKSEARCH_SPECTRUMKIND_XRD)
		pCmdUI->SetCheck(1);
	else 
		pCmdUI->SetCheck(0);
}

void CCurveFitDoc::OnViewProcessramandata() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_RAMAN;
	UpdateAllViews(NULL);
}

void CCurveFitDoc::OnUpdateViewProcessramandata(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	if(m_PeakSearch.m_SpectrumKind != PEAKSEARCH_SPECTRUMKIND_XRD)
		pCmdUI->SetCheck(1);
	else 
		pCmdUI->SetCheck(0);
}

void CCurveFitDoc::OnOptionLauncheditor() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CString command;
	char editor[256];
	IniFile->GetString("Preferences", "Editor", "notepad.exe", editor);
	command.Format("\"%s\"", editor);
	if(WinExec(command, SW_SHOW) < 32)
	{
		CString err;
		err = "Can't exec [" + command + "]";
		MessageBox(NULL, err, "Error in CCurveFitDoc::OnOptionLauncheditor", MB_OK);
		return;
	}
}

void CCurveFitDoc::OnFileSaverietanformat() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CGraphFrame frame;
	frame.AddData(m_PeakSearch.m_pOriginalData);
	frame.AddData(&(m_PeakSearch.m_BG));
	frame.AddData(&(m_PeakSearch.m_Total));
	for(int i = 0 ; i < m_PeakSearch.m_Curves.nGraphData() ; i++)
		frame.AddData(m_PeakSearch.m_Curves.GetGraphData(i));
	int ret = frame.SelectData();
	if(ret < 0) return;
	CVariousData *pData = (CVariousData*)frame.GetGraphData(ret);
	if(pData == NULL) return;
	
	char str[256];
	IniFile->GetString("Preferences", "WorkDir", "", str);
	if(*str != 0) SetCurrentDirectory(str);
	CFileDialog fd(false, "int", NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
		"Rietan int File (*.int)|*.int|All Files (*.*)|*.*||");
	if(fd.DoModal() != IDOK) return;

	pData->SaveAsRietanFormat((LPCSTR)fd.GetPathName());
}

void CCurveFitDoc::OnReadrietanfiles() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	int iDataIndex = 0;

	char str[256];
	IniFile->GetString("Preferences", "RietanDataDir", "", str);
	if(*str != 0) SetCurrentDirectory(str);
	CFileDialog fd(true, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
		"Rietan Data File (*.int;*.pat)|*.int;*.pat|All Files (*.*)|*.*||");
	if(fd.DoModal() != IDOK) return;

	GetPeakSearch()->RemoveAll();

	char filename[256];
	strcpy(filename, fd.GetPathName());
	strcpy(str, filename);
	char *cp = strrchr(str, '\\');
	if(cp) *cp = 0;
	IniFile->WriteString("Preferences", "RietanDataDir", str);

	if(CreateGraphFrameWithData(1) <= 0)
	{
		MessageBox(NULL, "Can't Create GraphFrame", "CDataFinderDoc::ReadDataFile", MB_OK);
		return;
	}
	CVariousGraphFrameArray *pFrameArray = GetGraphFrameArray();
	if(pFrameArray == NULL)
	{
		MessageBox(NULL, "Can't Get GraphFrameArray", "CDataFinderDoc::ReadDataFile", MB_OK);
		return;
	}
	CGraphFrame *pFrame = GetGraphFrame(0);
	if(pFrame == NULL)
	{
		MessageBox(NULL, "Can't Get GraphFrame", "CDataFinderDoc::ReadDataFile", MB_OK);
		return;
	}

	m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_INVALID;
	char FileTitle[256];
	cp = strrchr(filename, '.');
	if(cp == NULL)
	{
		sprintf(FileTitle, "%s (Invalid Data)", filename);
		SetPathName(FileTitle, TRUE);
		return;
	}
	int ret;
	if(stricmp(cp, ".int") == 0)
	{
		ret = GetOriginalData()->ReadRietanIntData(filename);
		pFrame->SetXAxisString(CString("2Theta"));
		pFrame->SetYAxisString(CString("Diffraction Intensity"));
		sprintf(FileTitle, "%s (Rietan INT Data)", filename);
		m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_XRD;
	}
	else if(stricmp(cp, ".pat") == 0)
	{
		ret = GetOriginalData()->ReadRietanPatData(filename, 0);
		CVariousData *pData = (CVariousData*)(pFrame->AddData(&(m_PeakSearch.m_Total)));
		pData->ReadRietanPatData(filename, 1);
		pData->m_LineLineColor = RGB(0xff, 0, 0);
		pData = (CVariousData *)&(m_PeakSearch.m_BG);
		if(pData->ReadRietanPatData(filename, 2) > 0)
		{
			pData = (CVariousData *)pFrame->AddData(&(m_PeakSearch.m_BG));
			pData->m_LineLineColor = RGB(0, 0xff, 0);
		}
		pFrame->SetXAxisString(CString("2Theta"));
		pFrame->SetYAxisString(CString("Diffraction Intensity"));
		sprintf(FileTitle, "%s (Rietan PAT Data)", filename);
		m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_XRD;
	}
	else //invalid data
	{
		sprintf(FileTitle, "%s (Invalid Data)", filename);
		SetPathName(FileTitle, TRUE);
		return;
	}
	if(ret > 0)
	{
		(m_GraphFrameArray.GetGraphFrame(0))->CalcFrameViewRange();
		SetPathName(FileTitle, TRUE);
	}
	else
	{
		sprintf(FileTitle, "%s (Invalid Data)", filename);
		SetPathName(FileTitle, TRUE);
		return;
	}

	UpdateAllViews(NULL);
	return;
}

void CCurveFitDoc::OnFileUpdatecurrentfile() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	char filename[256];
	strcpy(filename, m_FileName);
//	MessageBox(NULL, filename, "fn", MB_OK);
	ReadDataFile(filename);
	SetPathName(filename, TRUE);
	UpdateAllViews(NULL);
}

void CCurveFitDoc::OnReadtextfiles() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	int iDataIndex = 0;

	char str[256];
	IniFile->GetString("Preferences", "TextDataDir", "", str);
	if(*str != 0) SetCurrentDirectory(str);
	CFileDialog fd(true, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
		"Text Data File (*.txt;*.asc)|*.txt;*.asc|All Files (*.*)|*.*||");
	if(fd.DoModal() != IDOK) return;

	GetPeakSearch()->RemoveAll();

	char filename[256];
	strcpy(filename, fd.GetPathName());
	strcpy(str, filename);
	char *cp = strrchr(str, '\\');
	if(cp) *cp = 0;
	IniFile->WriteString("Preferences", "TextDataDir", str);

	if(CreateGraphFrameWithData(1) <= 0)
	{
		MessageBox(NULL, "Can't Create GraphFrame", "CDataFinderDoc::ReadDataFile", MB_OK);
		return;
	}
	CVariousGraphFrameArray *pFrameArray = GetGraphFrameArray();
	if(pFrameArray == NULL)
	{
		MessageBox(NULL, "Can't Get GraphFrameArray", "CDataFinderDoc::ReadDataFile", MB_OK);
		return;
	}
	CGraphFrame *pFrame = GetGraphFrame(0);
	if(pFrame == NULL)
	{
		MessageBox(NULL, "Can't Get GraphFrame", "CDataFinderDoc::ReadDataFile", MB_OK);
		return;
	}

	m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_INVALID;
	char FileTitle[256];
	cp = strrchr(filename, '.');
	if(cp == NULL)
	{
		sprintf(FileTitle, "%s (Invalid Data)", filename);
		SetPathName(FileTitle, TRUE);
		return;
	}
	int ret;
	ret = GetOriginalData()->ReadTextData(filename);
	pFrame->SetXAxisString(CString("X axis"));
	pFrame->SetYAxisString(CString("Y axis"));
	sprintf(FileTitle, "%s (Text Data)", filename);
	m_PeakSearch.m_SpectrumKind = PEAKSEARCH_SPECTRUMKIND_INVALID;

	GetGraphFrameArray()->CalcAllFrameViewRange();

	strcpy(str, filename);
	GetSetupCurveFitView()->m_InputPath = CString(str);;
	cp = strrchr(str, '.');
	if(cp) *cp = 0;
	sprintf(str+strlen(str), "#%d.pfc", iDataIndex);
	GetSetupCurveFitView()->m_PFCPath = str;
	if(cp != NULL) *cp = 0;
	sprintf(str+strlen(str), "#%d.out", iDataIndex);
	GetSetupCurveFitView()->m_OutputPath = str;
	GetSetupCurveFitView()->UpdateData(FALSE);
	
	UpdateAllViews(NULL);
	return;
}


int CCurveFitDoc::NewDocument()
{
	GetSetupCurveFitView()->ClearDialog();
	CPeakSearch *pPeak = GetPeakSearch();
	GetOriginalData()->RemoveAllData();
	pPeak->m_BG.RemoveAllData();
	pPeak->m_Total.RemoveAllData();
	pPeak->m_Curves.RemoveAllData();
	GetGraphFrameArray()->RemoveAllData();
	m_Comment = "";
	CreateGraphFrameWithData(1);
	return 1;
}
