#!/usr/bin/perl

use strict;
use Tk;

my $mw = MainWindow->new();
$mw->title("Unit conversion");

$mw->Label(
		-text => 'test: ', 
		-anchor => 'w'
	)->grid(
		-row => 0,
		-column => 0,
		-sticky => 'news'
		);

my $entvar = '30';
my $ent = $mw->Entry(
		-width => 50,
		-background => 'white',
		-textvariable => \$entvar,
		)->grid(
			-row => 0,
			-column => 1,
			-sticky => 'news'
			);
my $ent2 = $mw->Entry(
		-width => 50,
		-cursor => 'xterm',
		-background => 'white'
		)->grid(
			-row => 1,
			-column => 1,
			-sticky => 'news'
			);
my $scalevar = 30;
my $scale = $mw->Scale(
	-bigincrement => 10.0,
	-command => sub { print "Moved\n"; $entvar = $scalevar; },
	-cursor => 'hand2', #'sb_h_double_arrow',
	-orient => 'horizontal', #'vertical'
	-digits => 4,
	-from => 10,
	-to => 120,
	-label => 'label',
	-length => 30,
	-sliderlength => 10,
	-width => 5,
	-resolution => 1,
	-showvalue => 1,
	-takefocus => 1,
	-tickinterval => 20,
	-variable => \$scalevar,
	)->grid(
		-row => 2,
		-column => 1,
		-sticky => 'news'
		);
$mw->bind('all', '<Key>', [\&CheckLogin, Ev('K'), 0]);
$mw->bind($ent, '<Key>', [\&CheckLogin, Ev('K'), 1]);
$mw->bind($ent, '<Enter>', [\&CheckLogin, 'Enter', 1]);
$mw->bind($ent, '<Leave>', [\&CheckLogin, 'Leave', 1]);
$mw->bind($ent, '<Property>', [\&CheckLogin, 'Property', 1]);
$mw->bind($ent, '<FocusIn>', [\&CheckLogin, 'FocusIn', 1]);
$mw->bind($ent, '<FocusOut>', [\&CheckLogin, 'FocusOut', 1]);
$mw->bind($ent2, '<FocusIn>', [\&CheckLogin, 'FocusIn', 2]);
$mw->bind($ent2, '<FocusOut>', [\&CheckLogin, 'FocusOut', 2]);

MainLoop;
exit;


sub CheckLogin {
	my ($obj, $key, $idx) = @_;

	print "key($idx)=$key\n";
}