use strict;

use lib 'd:/Programs/Perl/lib';
use Jcode;
use MyCharConv;

my $s = "  RPOs@ J^JiKi Ђ炪ȂȃDF@ݶ kanki Shin-ichi "; #An-an sinkai Shinnichi sinnnichi-ka Toshio Kamiya kan kakasi -w < document\nKAKASI ł͕ZbgƂĎ̂̂𗝉܂B (Jb R ";
#my $s = "JLNPR";

if(0) {
open(IN, "kakasi.sjis") or die "$!";
$s = '';
while(1) {
	my $line = <IN>;
	last if(!defined $line);
	$s .= $line;
}
close(IN);
}

print "Original: $s\n\n";
print "Kakasi: "            . MyCharConv->new()->Kakasi($s, undef, "sjis", qw(-aH -jH -KH -JH -EH -kH)) . "\n\n";
print "Kakasi: "            . MyCharConv->new()->Kakasi($s, undef, "sjis", qw(-Ha -ja -Ka -Ja -Ea -ka)) . "\n\n";
print "Roma2Kana: "         . MyCharConv->new()->Roma2Kana($s) . "\n\n";
print "Zen2Han(Kakasi): "   . MyCharConv->new()->Zen2Han($s)   . "\n\n";
print "Zenkaku2Hankaku: "   . MyCharConv->new()->Zenkaku2Hankaku($s, "sjis")   . "\n\n";
print "Hankaku2Zenkaku: "   . MyCharConv->new()->Hankaku2Zenkaku($s, "sjis")   . "\n\n";
print "Hiragana2Katakana: " . MyCharConv->new()->Hiragana2Katakana($s, "sjis") . "\n\n";
print "Katakana2Hiragana: " . MyCharConv->new()->Katakana2Hiragana($s, "sjis") . "\n\n";
print "MIMEEncode: "        . MyCharConv->new()->MIMEEncode($s)       . "\n\n";
print "MIMEEncode: "        . MyCharConv->new()->MIMEEncodeByUTF8($s) . "\n\n";
