#===============================================
# TkFitting
#===============================================
package TkFitting;
# TkPlotModulěpNXƂ
use TkPlotModule;
@ISA = qw(TkPlotModule);

use strict;
use Utils;
use MyTk::GraphFrameArray;
use GraphData;

#============================================================
#@RXgN^AfXgN^i񑩁j
#============================================================
sub new
{
	my ($module, $app, $canvas) = @_;
	my $this = {};
	bless $this;
	$this->SetApplication($app);
#	$this->SetCanvas($canvas);
	return $this;
}

sub DESTROY
{
	my $this = shift;
	$this->SUPER::DESTROY(@_);
}

#============================================================
#@pNXŒ`ȂÓIo[֐
#============================================================

#============================================================
#@pNXŒ`ȂOt\֌Wo[֐
#============================================================

#============================================================
#@pNXŒ`ȂEBhE֌Wo[֐
#============================================================
# ȉAW̓ꍇ́Amw()̕W֐Ăяo
# undefԂƁAꂼ̃EWFbg쐬Ȃ

# EWFbgŜ̍쐬
# mw()->InitCreateWidgets()ĂяoA
# EBhE^CgύXĂ
sub CreateWidgets
{
	my ($this) = @_;
	my $mw = $this->mw();
	my $ret = $mw->InitCreateWidgets();
	my $Frame = $mw->Frame()->pack(-fill => 'x'); #{'DataClassFrame'};

	my $Frame6 = $Frame->MyFrame()->pack(-fill => 'x');
	my $s1 = $Frame6->Spinbox(
		qw/-from 1 -to 10 -width 10 -validate key/,
		-validatecommand => sub {
			my ($proposed, $changes, $current, $index, $type) = @_;
				return not $proposed =~ m/[^\d]/g;
			},
		)->pack(-side => 'left');
	my $s2 = $Frame6->Spinbox(
		qw/-from 0 -to 3 -increment .5 -format %05.2f -width 10/,
		)->pack(-side => 'left');
	my $s3 = $Frame6->Spinbox(
		-values => [qw/Canberra Sydney Melbourne Perth Adelaide Brisbane Hobart
		Darwin/, 'Alice Springs'],
		-width  => 10,
		)->pack(-side => 'left');

# f[^ۑt@CI
	my $Frame0 = $Frame->MyFrame()->pack(-fill => 'x');
	$this->{'FileLabel'} = $Frame0->MyLabel(
					-text => 'Save File:'
				)->pack(-side => 'left');
	$this->{'FileEntry'} = $Frame0->MyEntry(
			-width => 50,
			-takefocus => 1,
		)->pack(-side => 'left', -expand => 'yes', -fill => 'x');
	$this->{'FileEntry'}->focus();
	$this->{'FilePathButton'} = $Frame0->MyButton(
			-text => '&Choose',
			-takefocus => 1,
			-command => [ \&ChooseFile, $this, $this->{'FileEntry'} ],
		)->pack(-side => 'left');

# C^[o͂eLXg{bNX(Entry)
	my $Frame1 = $Frame->MyFrame()->pack(-fill => 'x');
	$this->{'IntervalLabel'} = $Frame1->MyLabel(
					-text => 'Interval:'
				)->pack(-side => 'left', -fill => 'x');
	$this->{'IntervalEntry'}     = $Frame1->MyEntry(
					-width => 30,
					-takefocus => 1,
				)->pack(-side => 'left', -expand => 'yes', -fill => 'x');
	$this->{'IntervalEntry'}->SetText("500");
	$this->{'IntervalUnitLabel'} = $Frame1->MyLabel(
					-text => 'ms'
				)->pack(-side => 'left');

# X֐͂eLXg{bNX(Entry)
	my $Frame3 = $Frame->MyFrame()->pack(-fill => 'x');
	$this->{'XFunctionLabel'} = $Frame3->MyLabel(
					-text => 'X Function:',
				)->pack(-side => 'left', -fill => 'x');
	$this->{'XFunctionEntry'} = $Frame3->MyEntry(
					-width => 50,
					-takefocus => 1,
				)->pack(-side => 'left', -expand => 'yes', -fill => 'x');
# XFunction̕ϐ$x,$yŗ^
# ""ŕ͂ނƁA$x,$yϐƌēWJ悤Ƃ̂ŃG[ɂȂ
# ''gƁA$ ꕶƂ݂ȂȂ
	$this->{'XFunctionEntry'}->SetText('$x*$x');

# Y֐͂eLXg{bNX(Entry)
	my $Frame4 = $Frame->MyFrame()->pack(-fill => 'x');
	$this->{'YFunctionLabel'} = $Frame4->MyLabel(
					-text => 'Y Function:',
				)->pack(-side => 'left', -fill => 'x');
	$this->{'YFunctionEntry'} = $Frame4->MyEntry(
					-width => 50,
					-takefocus => 1,
				)->pack(-side => 'left', -expand => 'yes', -fill => 'x');
	$this->{'YFunctionEntry'}->SetText('($x*$x+$y*$y)*exp(-$x)');

# Start(Stop){^Clear{^
	my $Frame2 = $Frame->MyFrame()->pack(-fill => 'x');
	$this->{'StartButton'} = $Frame2->MyButton(
					-text => 'Start',
					-takefocus => 1,
					-command => [ \&StartButton, $this, "Start" ],
				)->pack(-side => 'left', -fill => 'x');
	$this->{'ClearButton'} = $Frame2->MyButton(
					-text => 'Clear',
					-takefocus => 1,
					-command => [ \&StartButton, $this, "Clear" ],
				)->pack(-side => 'left', -fill => 'x');

# CEBhẼ^Cgݒ
	$mw->SetTitle("GPIB Simulation demo for TkPlot.pl");
	return $ret;
}

# t@CIyC쐬Ȃ
sub CreateSelectFilePane
{
	my ($this) = @_;
#	return $this->mw()->CreateSelectFilePane();
	return undef;
}

# t@CeXg{bNXAeLXg{bNX쐬Ȃ
sub CreateFileContentPane
{
	my ($this) = @_;
#	return $this->mw()->CreateFileContentPane();
	return undef;
}

# ̃Otg쐬
# FInitCreateGraphFrameArray  AvP[VNɈxĂ΂Ȃ
# @@CreateGraphFrame  Ot`惂W[ŁAf[^t@C̓ǂݍ݂̂тɌĂяo
sub InitCreateGraphFrameArray
{
	my ($this, $canvas) = @_;
# $canvasnꂽꍇA$this->Canvas()ɕۑ
#	$this->SetCanvas($canvas) if($canvas);
# $canvasnȂꍇA$this->Canvas()ݒ肷
#	$canvas = $this->Canvas() unless($canvas);
# $canvasnȂꍇ̂߁A$this->Canvas()Ăяo
	$canvas = $this->Canvas($canvas);
# pɂɎgϐ擾
# TkApplicationIuWFNg
	my $App = $this->App();
# TkPlotModuleIuWFNgB̏ꍇ́ATkGPIBTestNXgԂ
	my $pDataArray = $App->TkData();
# Init@C̐ݒ肩tHgݒ肷
	my $font = $App->{'GraphFrameFont'};
	my @font = split(/,/, $font) if($font);
# LoX̕`敝ƍ
	my $w = $canvas->width();
	my $h = $canvas->height();

# Otg̔zIuWFNgA{'GraphFrameArray'}Ɋi[
	my $GraphFrameArray = $this->{'GraphFrameArray'}
			= new GraphFrameArray($this->mw());
#			= new GraphFrameArray($this->mw(), $canvas);
# Ô߁AOtg̔zIuWFNgɂLoXTCYݒ
	$GraphFrameArray->SetCanvasSize($w, $h);

# OtgA$GraphFrame0Ɏ擾
	$GraphFrameArray->AddGraphFrame();
	my $GraphFrame0  = $GraphFrameArray->GetGraphFrame(0);

# Init@C̐ݒ肩Otg̈ʒuݒ肷
	my $FramePosStr0 = $App->{"GraphFramePosition"};
	$GraphFrame0->SetPositionByStr($FramePosStr0);

# Otg̖ڐɂ镶ݒ肷
	$GraphFrame0->SetXCaption("X");
	$GraphFrame0->SetYCaption('Y');

# Otg̕\͈͂ݒ肷B
	$GraphFrame0->SetViewRange(0, 0, 1, 1);

# f[^̔z
	my @X;
	my @Y;
# f[^̔z$GraphFrame0Ɍт
# AddGraphDataɂ́Af[^z̃t@Xn
#@@0,'black'́A 0AF'black'̐`  `Ȃ
#@@"dot", 1, "red", 0, "red",́A"red"Fdot`悷
#@@"XAutoSkip"́Af[^ʂƂɁAʂ̉𑜓xɍ킹ĕ`f[^XLbv
#@@Ō"x","y"́AX,Yf[^ɂ閼OBقƂǈӖ͂Ȃ
	$GraphFrame0->AddGraphData(\@X, \@Y, 0, 'black',
			"dot", 1, "red", 0, "red", "XAutoSkip",
			"x", "y");

	return undef;
}

#=======================================================================
#  bindꂽ֐
#=======================================================================

#t@CI{^ƂɌĂ΂
sub ChooseFile
{
	my ($this, $widget) = @_;
	my $fmask = '*.*';
	my $defstr = '';
	my $message = 'Choose file';
	my $dir = '';
	my $filepath = Dialog::OpenFileDialog($this->mw(), 
				'save', $fmask, $defstr, $message, $dir);
	if($filepath) {
		if($widget) {
			$widget->SetText($filepath);
		}
	}
	return $filepath;
}

#Start, Clear{^ꂽƂɌĂ΂
sub StartButton {
	my ($this, $action) = @_;

#$actionɁAǂ̃{^ꂽ̏񂪓
	if($action =~ /start/i) {
		my $button = $this->{'StartButton'};
		my $text = $button->GetText();
# Start{^ꂽƂAStart{^̏Ԃ"Start""Stop"
# ȂĂ邩ɂďς
		if($text =~ /start/i) {
print "Press for Start\n";
#t@C擾Ałɑ݂邩ǂ`FbN
			my $FileName = $this->{'FileEntry'}->GetText();
#t@CIĂȂƂ́AbZ[Woď𒆎~
			if(!$FileName) {
				$this->mw()->messageBox(
					-icon => "info",  # "info" "warning" "question"
					-type => "Ok",    # "YesNo" "YesNoCancel" "OkCancel" "RetryCancel"
					-title => 'Error on FileName',
					-message => "FileName is not selected.\nChoose it.");
				return undef;
			}
#t@C݂Ƃ́A㏑̊mF
			if(-e $FileName) {
				my $ret = $this->mw()->messageBox(
					-icon => "question",  # "info" "warning" "question"
					-type => "YesNo",    # "YesNo" "YesNoCancel" "OkCancel" "RetryCancel"
					-title => 'Confirm for overwrite',
					-message => "$FileName exists.\nOverwrite?");
				return unless($ret eq 'Yes');
			}

#t@C݂悤ɃI[v
			$this->{'OutFileClass'} = new JFile($FileName, "w");
			if(!$this->{'OutFileClass'}) {
				$this->mw()->messageBox(
					-icon => "info",  # "info" "warning" "question"
					-type => "Ok",    # "YesNo" "YesNoCancel" "OkCancel" "RetryCancel"
					-title => 'Error',
					-message => "Can not write to $FileName.");
				return undef;
			}

			$button->SetText("Stop");
			$this->{'DoStop'} = 0;
			$this->{'Count'}  = 0;
# f[^̓ǂݍ݂[vōsƁA{^̍XVȂǂłȂ̂ŁA
# ^C}[(mw()->after())g$itime msMeasure()֐Ăяo
			my $itime = $this->{'IntervalEntry'}->GetText();
			$this->mw()->after($itime, [\&Measure, $this]);
		}
		elsif($text =~ /stop/i) {
print "Press for Stop\n";
# t@CI[vĂāAϐundef
			if($this->{'OutFileClass'}) {
				$this->{'OutFileClass'}->Close();
				undef $this->{'OutFileClass'};
			}

			$button->SetText("Start");
			$this->{'DoStop'} = 1;
		}
	}
	elsif($action =~ /clear/i) {
print "Press for Clear\n";
# OtzIuWFNgAf[^$dataIuWFNgoB
		my $GraphFrameArray = $this->{'GraphFrameArray'};
		my $GraphFrame = $GraphFrameArray->GetGraphFrame(0);
		my $data = $GraphFrame->GetPlotData(0);
# $dataɓo^ꂽf[^폜B
# $datãf[^̍ŏEől͎IɍXV
		$data->ClearAll();

# $GraphFramẽf[^̍ŏEőlXV
		$GraphFrame->CalMinMax();
# ĕ`
		$this->Draw();
	}
}

sub Measure
{
	my ($this) = @_;
#"Stop"{^ƁA'DoStop'1ɂȂ
#̂ƂAɋA
	return if($this->{'DoStop'});

	my $GraphFrameArray = $this->{'GraphFrameArray'};
	my $GraphFrame = $GraphFrameArray->GetGraphFrame(0);
	my $data = $GraphFrame->GetPlotData(0);

#Start: GPIBV~[V[`FGPIBŃf[^$x,$yɎ󂯎
	my $x = rand();
	my $y = rand();
#End: GPIBV~[V[`


#JE^[ϐ擾
	my $c = $this->{'Count'};
#f[^R\[ɕ\
	$x = Utils::Round($x, 4); #L4ɐ؂l߂
	$y = Utils::Round($y, 4); #L4ɐ؂l߂
	print "$c: ($x,$y)\n";
#f[^t@Cɏ
	if($this->{'OutFileClass'}) {
		$this->{'OutFileClass'}->Write("$c\t$x\t$y\n");
	}

#f[^R\[ɕ\iʂ͎̂Psj
#	$data->AddData($x, $y);
#Start:ƗVсF$x,$yX,YFunctioneLXg{bNX̊֐]A
	#@@@@@@@vbg
		my $xfunc = $this->{'XFunctionEntry'}->GetText();
		my $yfunc = $this->{'YFunctionEntry'}->GetText();
	# $func̕ϐ$x,$yŗ^Ă
	# $x0~1Ȃ̂ŁA0~10̒lɕϊ
		$x = $x * 10;
		$y = $y * 10;
		my $x1 = eval($xfunc);
		my $y1 = eval($yfunc);
		$data->AddData($x1, $y1);
#End:ƗV

#f[^$GraphFrame̍őEŏlXV
	$data->CalMinMax();
	$GraphFrame->CalMinMax();
#f[^͈̔͂ɂ킹$GraphFrame̕`͈͂ςꍇA
#AdjustViewRangeĂԁBƂ肠A0.05ɂ͈Ӗ͂Ȃ
	$GraphFrame->AdjustViewRange(0.05, 0.05, 0.05, 0.05);
#ŌĂяoKv͂ȂA\͈͂Œ肷ꍇA
#SetViewRangeĂԁB
#	$GraphFrame->SetViewRange(0, 0, 1, 1);

#ĕ`
	$this->Draw();

#JE^[ϐXV
	$this->{'Count'} += 1;

#̂܂܂ŏIƁA񂵂Measure֐ĂяoȂ̂ŁA
#JԂ邽߁Aēxafter()$itime msMeasure֐ĂяoB
	my $itime = $this->{'IntervalEntry'}->GetText();
	$this->mw()->after($itime, [\&Measure, $this]);
}

1;